;;; binding-jgoodies.lisp
;;;
;;; Copyright (C) 2008-2009 Alessio Stalla
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;;;
;;; As a special exception, the copyright holders of this library give you
;;; permission to link this library with independent modules to produce an
;;; executable, regardless of the license terms of these independent
;;; modules, and to copy and distribute the resulting executable under
;;; terms of your choice, provided that you also meet, for each linked
;;; independent module, the terms and conditions of the license of that
;;; module.  An independent module is a module which is not derived from
;;; or based on this library.  If you modify this library, you may extend
;;; this exception to your version of the library, but you are not
;;; obligated to do so.  If you do not wish to do so, delete this
;;; exception statement from your version.

(in-package :snow)

(defmethod bind-widget ((widget (jclass "javax.swing.JTextField")) binding)
  (jstatic (jmethod "com.jgoodies.binding.adapter.Bindings"
		    "bind"
		    "javax.swing.JTextField"
		    "com.jgoodies.binding.value.ValueModel"
		    "boolean")
	   nil widget (make-model binding)
	   (make-immediate-object t :boolean)))

(defmethod bind-widget ((widget (jclass "javax.swing.JLabel")) binding)
  (jstatic (jmethod "com.jgoodies.binding.adapter.Bindings"
		    "bind"
		    "javax.swing.JLabel"
		    "com.jgoodies.binding.value.ValueModel")
	   nil widget (make-model binding)))

(defmethod (setf widget-property) ((value data-binding) (widget (jclass "java.awt.Component")) name)
  (jstatic (jmethod "com.jgoodies.binding.adapter.Bindings"
		    "bind"
		    "javax.swing.JComponent"
		    "java.lang.String"
		    "com.jgoodies.binding.value.ValueModel")
	   nil widget (dashed->camelcased name) (make-model value))
  value)
